#include "stdafx.h"
#include "CVCommon.h"


void SetSingleIntValue(IplImage *img, int x, int y, int value)
{
	((uchar*)(img->imageData + img->widthStep*y))[x] = value;
}
int GetSingleIntValue(IplImage *img, int x, int y)
{
	return (int)((uchar*)(img->imageData + img->widthStep*y))[x];
}

void SetImageIntValue(IplImage *img, int x, int y, int value, int channel)
{
	((uchar*)(img->imageData + img->widthStep*y))[3*x+channel] = value;
}

int GetImageIntValue(IplImage *img, int x, int y, int channel)
{
	return (int)((uchar*)(img->imageData + img->widthStep*y))[3*x+channel];
}

void mat2Image(CvMat *mat, IplImage *img, int chnl)
{
	int w = mat->height;
	int h = mat ->width;
	for(int i=0; i<w; i++){
		for(int j=0; j<h; j++){
			((uchar*)(img->imageData + img->widthStep*j))[3*i+chnl] = (uchar)(cvmGet(mat,i,j)*255);
		}
	}
}

void Image2mat(IplImage *img, CvMat *mat , int chnl)
{
	int w = mat->height;
	int h = mat->width;
	double val;
	for(int i=0; i<w; i++){
		for(int j=0; j<h; j++){
			val = ((uchar*)(img->imageData + img->widthStep*j))[3*i+chnl];
			cvmSet(mat, i,j, val /255.0);			 
		}
	}
}

int trisign(int x)// (1,0,-1)
{
	if(x>0)
		return 1;
	else if(x<0)
		return -1;
	else 
		return 0;
}
