// MainFrm.h : interface of the CMainFrame class
//


#pragma once

#include "CVWindow.h"
class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
	CVWindow *chdwnd; // child window, only one at a time
	// parameters
	double mu, lambda1, lambda2,dt, k;
	bool vout;
	char vfname[100];
	int stype; //0:GC, 1:PDE
	int cshape; //0:Freeform, 1:Rectangular, 2:Circle
	int ztype; //0: half, 1:normal, 2:double
public:
	CMainFrame();

// Attributes
public:

// Operations
public:
	void SetXCoord(int x);
	void SetYCoord(int y);
	void SetFrmNum(int fn);
	void SetFrmTime(__time64_t time);
	void SetTotalTime(__time64_t ltime);

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndFileToolBar;
	CToolBar    m_wndControlBar;
public:
	CDialogBar  m_wndDlgBar;

// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	DECLARE_MESSAGE_MAP()

	afx_msg void OnFileOpen();	
	afx_msg void OnUpdateControlBar();//CCmdUI* pCmdUI);

public:
	void ClearChdWnd(void);
	afx_msg void OnViewToolbar();
	afx_msg void OnUpdateViewToolbar(CCmdUI *pCmdUI);
	afx_msg void OnViewControlbar();
	afx_msg void OnUpdateViewControlbar(CCmdUI *pCmdUI);
};


