// TPCut.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "TGraphImage.h"
#include <fstream>
#include <iostream>

using namespace std;

int width, height;

TGraphImage* init_param(char *filename)
{
	ifstream in(filename);
	if(!in.is_open())
		return NULL;

	double w_edge, w_tweight;
	int *label;
	int cnum, contour_num;

	in >> width >> height;
	in >> w_edge;

	TGraphImage *tg = new TGraphImage(width, height);
	label = new int[width*height];

	for(int i = 0; i < width - 1; i++) {
		for(int j = 0; j < height - 1; j++) {
			tg->add_edge(i, j, i+1, j, w_edge);
			tg->add_edge(i, j, i, j+1, w_edge);
		}
	}
	for(int i = 0; i < width - 1; i++) tg->add_edge(i, height - 1, i+1, height - 1, w_edge);
	for(int i = 0; i < height -1; i++) tg->add_edge(width - 1, i, width - 1, i+1, w_edge);

	for(int i = 0; i < width; i++) {
		for(int j = 0; j < height; j++) {
			in >> label[i*height + j];			
		}
	}
	
	for(int i = 0; i < width; i++) {
		for(int j = 0; j < height; j++) {
			in >> w_tweight;
			if(label[i*height + j] == 0) tg->set_tweights(i, j, 0, w_tweight);
			else tg->set_tweights(i, j, w_tweight, 0);
		}
	}

	in >> contour_num;
	while(contour_num--) {
		in >> cnum;
		int *x = new int[cnum];
		int *y = new int[cnum];
		for(int i = 0; i < cnum; i++) {
			in >> x[i] >> y[i];
		}

		tg->add_contour(x, y, cnum);

		delete[] x;
		delete[] y;		
	}

	delete[] label;
	return tg;
}


void showResult(TGraphImage *tg)
{
	for (int i = 0; i < width; i++) {
		for(int j = 0; j < height; j++) {
			if( tg->what_segment(i, j) == TGraphImage::FOREGROUND )
				cout << "1 ";
			else if( tg->what_segment(i, j) == TGraphImage::BACKGROUND ) 
				cout << "0 ";
			else
				cout << "- ";
		}
		cout << endl; 
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	TGraphImage *tg;

	if(! (tg = init_param("./data2.txt")))
		return 0;
	
	tg->maxflow();

	showResult(tg);

	delete tg;

	return 0;
}

